%define lname libhwy1

Name:           highway
Version:        1.0.4
Release:        %mkrel 1
Summary:        C++ library providing SIMD/vector intrinsics
License:        Apache-2.0
Group:          Development/C and C++
URL:            https://github.com/google/highway
Source:         https://github.com/google/highway/release/%{version}/%{name}-%{version}.tar.gz
Source1:        baselibs.conf
BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  pkgconf-pkg-config
BuildRequires:  pkgconfig(gtest)
BuildArch:		x86_64
ExclusiveArch:	i586 x86_64 aarch64

%description
Highway is a C++ library that provides portable SIMD/vector intrinsics.

%package -n %lname
Summary:        Efficient and performance-portable SIMD
Group:          Development/C and C++

%description -n %lname
Highway is a C++ library that provides portable SIMD/vector intrinsics.

%package devel
Summary:        Development files for Highway
Group:          Development/C and C++
Requires:       %lname = %version

%description devel
Highway is a C++ library that provides portable SIMD/vector intrinsics.

Development files for Highway.

%package devel-doc
Summary:        Documentation for Highway
Group:          Documentation/Other
BuildArch:      noarch

%description devel-doc
Highway is a C++ library that provides portable SIMD/vector intrinsics.

Documentation for Highway development.

%prep
%autosetup -p1

%build
export CFLAGS="%optflags -DHWY_COMPILE_ALL_ATTAINABLE"
%ifarch ppc64 ppc64le
CFLAGS="$CFLAGS -maltivec"
%endif
export CXXFLAGS="$CFLAGS"

%cmake \
%ifarch %arm
	-DHWY_CMAKE_ARM7:BOOL=OFF \
%endif
	-DCMAKE_SKIP_RPATH:BOOL=OFF \
	-DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
	-DHWY_SYSTEM_GTEST:BOOL=ON
%cmake_build

%install
%cmake_install

%check
export CTEST_PARALLEL_LEVEL=2
%ctest --parallel 2 --verbose || :

%post   -n %lname -p /sbin/ldconfig
%postun -n %lname -p /sbin/ldconfig

%files -n %lname
%_libdir/libhwy*.so.*
%license LICENSE

%files devel
%_includedir/hwy/
%_libdir/libhwy*.so
%_libdir/pkgconfig/*.pc
%_libdir/cmake/

%files devel-doc
%doc README.md g3doc/* hwy/examples/
